## mongo-cxx-driver 4.0.0

=== CMakeLists.txt ===
# Copyright 2009-present MongoDB, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.15)

if(POLICY CMP0025)
    cmake_policy(SET CMP0025 NEW)
endif()

project(MONGO_CXX_DRIVER LANGUAGES CXX)

set(CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH}
    ${PROJECT_SOURCE_DIR}/cmake
    ${PROJECT_SOURCE_DIR}/cmake/make_dist
)

option(BUILD_TESTING "When ENABLE_TESTS=ON, include test targets in the \"all\" target")

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.8.2")
        message(FATAL_ERROR "Insufficient GCC version - GCC 4.8.2+ required")
    endif()
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "19.0.23506")
        message(FATAL_ERROR "Insufficient Microsoft Visual C++ version - MSVC 2015 Update 1+ required")
    endif()
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
    if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "5.1")
        message(FATAL_ERROR "Insufficient Apple clang version - XCode 5.1+ required")
    endif()
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "3.5")
        message(FATAL_ERROR "Insufficient clang version - clang 3.5+ required")
    endif()
else()
    message(WARNING "Unknown compiler... recklessly proceeding without a version check")
endif()

# Also update etc/purls.txt.
set(LIBBSON_REQUIRED_VERSION 1.29.0)
set(LIBBSON_REQUIRED_ABI_VERSION 1.0)

# Also update etc/purls.txt.
set(LIBMONGOC_REQUIRED_VERSION 1.29.0)
set(LIBMONGOC_DOWNLOAD_VERSION 1.29.0)
set(LIBMONGOC_REQUIRED_ABI_VERSION 1.0)

set(NEED_DOWNLOAD_C_DRIVER false)

if(TARGET mongoc_shared OR TARGET mongoc_static)
    # If these targets exist, then libmongoc has already been included as a project
    # sub-directory
    message(STATUS "Found libmongoc targets declared in current build scope; version not checked")
else()
    find_package(mongoc-${LIBMONGOC_REQUIRED_ABI_VERSION} ${LIBMONGOC_REQUIRED_VERSION} QUIET)

    if(mongoc-${LIBMONGOC_REQUIRED_ABI_VERSION}_FOUND)
        message(STATUS "Found libmongoc ${mongoc-${LIBMONGOC_REQUIRED_ABI_VERSION}_VERSION}, don't need to download it.")
    else()
        set(NEED_DOWNLOAD_C_DRIVER true CACHE INTERNAL "")
    endif()
endif()

if(NEED_DOWNLOAD_C_DRIVER)
    message(STATUS "No MongoDB C Driver path provided via CMAKE_PREFIX_PATH, will download C driver version ${LIBMONGOC_DOWNLOAD_VERSION} from the internet.")
    include(FetchMongoC)
endif()

# All of our target compilers support the deprecated
# attribute. Normally, we would just let the GenerateExportHeader
# subsystem do this via configure check, but there appears to be a
# CMake bug where if -Werror is set on the command line, it breaks the
# configure check, and we end up not configuring the macro. That means
# that we end up not being able to turn deprecation warnings into
# errors. Instead, since we know all our platforms offer the feature,
# just hard enable it here.
if(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    set(COMPILER_HAS_DEPRECATED true)
else()
    set(COMPILER_HAS_DEPRECATED_ATTR true)
endif()

set(CMAKE_SKIP_BUILD_RPATH false)
set(CMAKE_BUILD_WITH_INSTALL_RPATH false)
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH true)

# Ensure that RPATH is used on OSX
set(CMAKE_MACOSX_RPATH 1)

# Enforce the C++ standard, and disable extensions
if(NOT DEFINED CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 11)
endif()

set(CMAKE_CXX_EXTENSIONS OFF)

# Include the required modules
include(CMakeDependentOption)
include(GenerateExportHeader)
include(InstallRequiredSystemLibraries)

# Allow the user to decide whether to build the shared libaries or the static libraries.
option(BUILD_SHARED_LIBS "Build shared libraries" ON)
set(BUILD_VERSION "0.0.0" CACHE STRING "Library version (for both libbsoncxx and libmongocxx)")

# Allow the user to decide whether to also build static libraries
option(BUILD_SHARED_AND_STATIC_LIBS "Build static libraries" OFF)

# Allow the user to decide whether to use shared libraries or static libraries
# for the mongo-c-driver
option(BUILD_SHARED_LIBS_WITH_STATIC_MONGOC
    "Use static mongo-c-driver libraries with shared mongo-cxx-driver libraries"
    OFF
)

if(DEFINED CACHE{ENABLE_ABI_TAG_IN_LIBRARY_FILENAMES} AND NOT MSVC)
    message(WARNING "ENABLE_ABI_TAG_IN_LIBRARY_FILENAMES is an MSVC-only option and will be ignored by the current configuration")
    unset(ENABLE_ABI_TAG_IN_LIBRARY_FILENAMES CACHE)
endif()

if(DEFINED CACHE{ENABLE_ABI_TAG_IN_PKGCONFIG_FILENAMES} AND NOT $CACHE{ENABLE_ABI_TAG_IN_LIBRARY_FILENAMES})
    message(WARNING "ENABLE_ABI_TAG_IN_PKGCONFIG_FILENAMES requires ENABLE_ABI_TAG_IN_LIBRARY_FILENAMES=ON and will be ignored by the current configuration")
    unset(ENABLE_ABI_TAG_IN_PKGCONFIG_FILENAMES CACHE)
endif()

# Allow user to disable embedding of ABI tag in library filenames (MSVC only).
cmake_dependent_option(ENABLE_ABI_TAG_IN_LIBRARY_FILENAMES "Embed ABI tag in library filenames" ON "MSVC" OFF)

# Allow user to enable embedding of ABI tag in pkg-config metadata filenames (MSVC only).
cmake_dependent_option(ENABLE_ABI_TAG_IN_PKGCONFIG_FILENAMES "Embed ABI tag in pkg-config metadata filenames" OFF "ENABLE_ABI_TAG_IN_LIBRARY_FILENAMES" OFF)

option(ENABLE_UNINSTALL "Enable creation of uninstall script and associated uninstall build target." ON)

# Allow the user to enable code coverage
option(ENABLE_CODE_COVERAGE "Enable code coverage." OFF)

# Disambiguate our options into clear flags
if(BUILD_SHARED_LIBS)
    set(BSONCXX_BUILD_SHARED ON CACHE INTERNAL "")
    set(MONGOCXX_BUILD_SHARED ON CACHE INTERNAL "")

    if(BUILD_SHARED_AND_STATIC_LIBS)
        set(BSONCXX_BUILD_STATIC ON CACHE INTERNAL "")
        set(MONGOCXX_BUILD_STATIC ON CACHE INTERNAL "")
    else()
        set(BSONCXX_BUILD_STATIC OFF CACHE INTERNAL "")
        set(MONGOCXX_BUILD_STATIC OFF CACHE INTERNAL "")
    endif()

    if(BUILD_SHARED_LIBS_WITH_STATIC_MONGOC)
        set(BSONCXX_LINK_WITH_STATIC_MONGOC ON CACHE INTERNAL "")
        set(MONGOCXX_LINK_WITH_STATIC_MONGOC ON CACHE INTERNAL "")
    else()
        set(BSONCXX_LINK_WITH_STATIC_MONGOC OFF CACHE INTERNAL "")
        set(MONGOCXX_LINK_WITH_STATIC_MONGOC OFF CACHE INTERNAL "")
    endif()
else()
    # Give a fatal error if we have a non-sensical combination
    if(BUILD_SHARED_AND_STATIC_LIBS)
        message(FATAL_ERROR
            "BUILD_SHARED_LIBS is OFF but BUILD_SHARED_AND_STATIC_LIBS is ON. \
To build static libraries only, set both BUILD_SHARED_LIBS and BUILD_SHARED_AND_STATIC_LIBS to OFF"
        )
    endif()

    set(BSONCXX_BUILD_SHARED OFF CACHE INTERNAL "")
    set(MONGOCXX_BUILD_SHARED OFF CACHE INTERNAL "")

    set(BSONCXX_BUILD_STATIC ON CACHE INTERNAL "")
    set(MONGOCXX_BUILD_STATIC ON CACHE INTERNAL "")

    set(BSONCXX_LINK_WITH_STATIC_MONGOC ON CACHE INTERNAL "")
    set(MONGOCXX_LINK_WITH_STATIC_MONGOC ON CACHE INTERNAL "")
endif()

include(GNUInstallDirs)
include(ParseVersion)

set(MONGOCXX_INCLUDE_VERSION_FILE_IN_DIST OFF)
set(MONGOCXX_CURRENT_VERSION_FILE "")

if(BUILD_VERSION STREQUAL "0.0.0")
    if(EXISTS ${CMAKE_BINARY_DIR}/VERSION_CURRENT)
        file(STRINGS ${CMAKE_BINARY_DIR}/VERSION_CURRENT BUILD_VERSION)
        if("${CMAKE_BINARY_DIR}" STREQUAL "${PROJECT_SOURCE_DIR}/build")
            # If `CMAKE_BINARY_DIR` is the `build` directory, include `VERSION_CURRENT` in the release tarball.
            set(MONGOCXX_INCLUDE_VERSION_FILE_IN_DIST ON)
            set(MONGOCXX_CURRENT_VERSION_FILE build/VERSION_CURRENT)
        endif ()
    elseif(EXISTS ${PROJECT_SOURCE_DIR}/build/VERSION_CURRENT)
        set(MONGOCXX_INCLUDE_VERSION_FILE_IN_DIST ON)
        set(MONGOCXX_CURRENT_VERSION_FILE build/VERSION_CURRENT)
        file(STRINGS ${MONGOCXX_CURRENT_VERSION_FILE} BUILD_VERSION)
    else()
        find_package(PythonInterp)

        if(PYTHONINTERP_FOUND)
            execute_process(
                COMMAND ${PYTHON_EXECUTABLE} etc/calc_release_version.py
                WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
                OUTPUT_VARIABLE CALC_RELEASE_VERSION
                RESULT_VARIABLE CALC_RELEASE_VERSION_RESULT
                OUTPUT_STRIP_TRAILING_WHITESPACE
            )

            if(NOT CALC_RELEASE_VERSION_RESULT STREQUAL 0)
                # If python failed above, stderr would tell the user about it
                message(FATAL_ERROR
                    "BUILD_VERSION not specified and could not be calculated\
 (script invocation failed); specify in CMake command, -DBUILD_VERSION=<version>"
                )
            else()
                set(BUILD_VERSION ${CALC_RELEASE_VERSION})
                file(WRITE ${CMAKE_BINARY_DIR}/VERSION_CURRENT ${CALC_RELEASE_VERSION})
            endif()
        else()
            message(FATAL_ERROR
                "BUILD_VERSION not specified and could not be calculated\
 (Python was not found on the system); specify in CMake command, -DBUILD_VERSION=<version>"
            )
        endif()
    endif()
endif()

get_property(isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)

if(NOT CMAKE_BUILD_TYPE AND NOT isMultiConfig)
    # Do not override CMAKE_BUILD_TYPE if generator is multi config. CMAKE_BUILD_TYPE is ignored for multi-config generators.
    message(STATUS "No build type selected, default is Release")
    set(CMAKE_BUILD_TYPE "Release")
endif()

if(ENABLE_CODE_COVERAGE)
    if(NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
        message(WARNING "Code coverage results with an optimized (non-Debug) build may be misleading")
    endif()

    if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0 -g --coverage")
    elseif(CMAKE_CXX_COMPILER_ID MATCHES "(Apple)?[Cc]lang")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-instr-generate -fcoverage-mapping")
    else()
        message(FATAL_ERROR "Code coverage requires Clang or GCC. Aborting.")
    endif()
endif()

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

unset(dist_generated CACHE)
unset(dist_generated_depends CACHE)

set(BUILD_SOURCE_DIR ${CMAKE_BINARY_DIR})

include(MakeDistFiles)

add_custom_target(hugo_dir
    COMMAND ${CMAKE_COMMAND} -E make_directory hugo
)

add_custom_target(hugo
    DEPENDS hugo_dir
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/docs
    COMMAND hugo
    VERBATIM
)

add_custom_target(hugo-deploy
    DEPENDS hugo
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMAND etc/deploy-to-ghpages.pl --hugo git@github.com:mongodb/mongo-cxx-driver
    VERBATIM
)

add_custom_target(docs_dir_current
    COMMAND ${CMAKE_COMMAND} -E make_directory docs/api/current
)

add_custom_target(doxygen-current
    DEPENDS docs_dir_current
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMAND doxygen ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile
    VERBATIM
)

add_custom_target(doxygen-latest
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMAND etc/generate-latest-apidocs.pl
    VERBATIM
)

add_custom_target(doxygen-deploy
    DEPENDS doxygen-latest
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMAND etc/deploy-to-ghpages.pl --doxygen git@github.com:mongodb/mongo-cxx-driver
    VERBATIM
)

add_custom_target(format
    python ${CMAKE_SOURCE_DIR}/etc/clang_format.py format
    VERBATIM
)

add_custom_target(format-lint
    python ${CMAKE_SOURCE_DIR}/etc/clang_format.py lint
    VERBATIM
)

add_custom_target(docs
    DEPENDS hugo doxygen-current
)

set(THIRD_PARTY_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src/third_party)

=== examples/add_subdirectory/CMakeLists.txt ===
# Copyright 2009-present MongoDB, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Demonstrates how to use the CMake 'add_subdirectory' mechanism to locate and
# build against the libmongoc and libmongocxx shared libraries.

cmake_minimum_required(VERSION 3.2 FATAL_ERROR)

if(POLICY CMP0025)
    cmake_policy(SET CMP0025 NEW)
endif()

project(HELLO_WORLD LANGUAGES C CXX)

# Enforce the C++ standard, and disable extensions.
if(NOT DEFINED CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 11)
endif()

set(CMAKE_CXX_EXTENSIONS OFF)

set(BUILD_SHARED_AND_STATIC_LIBS ON CACHE BOOL "" FORCE)
set(ENABLE_TESTS OFF CACHE BOOL "" FORCE)
add_subdirectory(mongo-c-driver)
add_subdirectory(mongo-cxx-driver)

add_executable(hello_mongocxx hello_mongocxx.cpp)

target_link_libraries(hello_mongocxx
  PRIVATE mongocxx_static
)

add_custom_target(run
    COMMAND hello_mongocxx
    DEPENDS hello_mongocxx
    WORKING_DIRECTORY ${CMAKE_PROJECT_DIR}
)

=== src/bsoncxx/CMakeLists.txt ===
# Copyright 2009-present MongoDB, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

project(BSONCXX)

ParseVersion(${BUILD_VERSION} BSONCXX)

set(BSONCXX_VERSION_NO_EXTRA ${BSONCXX_VERSION_MAJOR}.${BSONCXX_VERSION_MINOR}.${BSONCXX_VERSION_PATCH})
set(BSONCXX_VERSION ${BSONCXX_VERSION_NO_EXTRA}${BSONCXX_VERSION_EXTRA})
message(STATUS "bsoncxx version: ${BSONCXX_VERSION}")

option(BSONCXX_POLY_USE_IMPLS "Use bsoncxx implementations for stdx polyfills" OFF)
option(BSONCXX_POLY_USE_STD "Use C++17 std library for stdx polyfills" OFF)

set(BSONCXX_OUTPUT_BASENAME "bsoncxx" CACHE STRING "Output bsoncxx library base name")

# Count how many polyfill options are true-ish
set(BSONCXX_POLY_OPTIONS_SET 0)

foreach(BSONCXX_POLY_OPTION ${BSONCXX_POLY_USE_IMPLS} ${BSONCXX_POLY_USE_STD})
    if(${BSONCXX_POLY_OPTION})
        MATH(EXPR BSONCXX_POLY_OPTIONS_SET "${BSONCXX_POLY_OPTIONS_SET}+1")
    endif()
endforeach()

if(BSONCXX_POLY_OPTIONS_SET GREATER 1)
    # You can't ask for more than one polyfill
    message(FATAL_ERROR "Cannnot specify more than one bsoncxx polyfill choice")
elseif(BSONCXX_POLY_OPTIONS_SET EQUAL 0)
    # You can just not say, in which case we endeavor to pick a sane default:
    if(NOT CMAKE_CXX_STANDARD LESS 17)
        # If we are in C++17 mode, use the C++17 versions
        set(BSONCXX_POLY_USE_STD ON)
        message(STATUS "Auto-configuring bsoncxx to use C++17 std library polyfills since C++17 is active and user didn't specify otherwise")
    else()
        # If enabled, use bsoncxx implementations instead of external libraries.
        set(BSONCXX_POLY_USE_IMPLS ON)
        message(STATUS "Auto-configuring bsoncxx to use its own polyfill implementations since C++17 is inactive")
    endif()
endif()

set(BSONCXX_PKG_DEP "") # Required by bsoncxx-config.cmake.in.

if(TARGET bson_shared OR TARGET bson_static)
    # If these targets exist, then libbson has already been included as a project
    # sub-directory
    message(STATUS "found libbson targets declared in current build scope; version not checked")

    if(NOT BSONCXX_LINK_WITH_STATIC_MONGOC)
        set(libbson_target bson_shared)
    else()
        set(libbson_target bson_static)
    endif()

    set(BSONCXX_PKG_DEP "find_dependency(bson-${LIBBSON_REQUIRED_ABI_VERSION} REQUIRED)")
else()
    # Attempt to find libbson by new package name (without lib).
    find_package(bson-${LIBBSON_REQUIRED_ABI_VERSION} ${LIBBSON_REQUIRED_VERSION} QUIET)

    if(bson-${LIBBSON_REQUIRED_ABI_VERSION}_FOUND)
        message(STATUS "found libbson version ${bson-${LIBBSON_REQUIRED_ABI_VERSION}_VERSION}")

        if(NOT BSONCXX_LINK_WITH_STATIC_MONGOC)
            set(libbson_target mongo::bson_shared)
        else()
            set(libbson_target mongo::bson_static)
        endif()

        set(BSONCXX_PKG_DEP "find_dependency(bson-${LIBBSON_REQUIRED_ABI_VERSION} REQUIRED)")
    else()
        # Require package of old libbson name (with lib).
        if(NOT BSONCXX_LINK_WITH_STATIC_MONGOC)
            find_package(libbson-${LIBBSON_REQUIRED_ABI_VERSION} ${LIBBSON_REQUIRED_VERSION} REQUIRED)
            message(STATUS "found libbson version ${BSON_VERSION}")
            set(libbson_target ${BSON_LIBRARIES})
            set(libbson_include_directories ${BSON_INCLUDE_DIRS})
            set(libbson_definitions ${BSON_DEFINITIONS})
            set(BSONCXX_PKG_DEP "find_dependency(libbson-${LIBBSON_REQUIRED_ABI_VERSION} REQUIRED)")
        else()
            find_package(libbson-static-${LIBBSON_REQUIRED_ABI_VERSION} ${LIBBSON_REQUIRED_VERSION} REQUIRED)
            message(STATUS "found libbson version ${BSON_STATIC_VERSION}")
            set(libbson_target ${BSON_STATIC_LIBRARIES})
            set(libbson_include_directories ${BSON_STATIC_INCLUDE_DIRS})
            set(libbson_definitions ${BSON_STATIC_DEFINITIONS})
            set(BSONCXX_PKG_DEP "find_dependency(libbson-static-${LIBBSON_REQUIRED_ABI_VERSION} REQUIRED)")
        endif()
    endif()
endif()

set(bsoncxx_sources "") # Required by bsoncxx_add_library().

add_subdirectory(include)
add_subdirectory(lib)

include(BsoncxxUtil)

set(bsoncxx_target_list "")

if(BSONCXX_BUILD_SHARED)
    bsoncxx_add_library(bsoncxx_shared "${BSONCXX_OUTPUT_BASENAME}" SHARED)
    list(APPEND bsoncxx_target_list bsoncxx_shared)

    if(WIN32)
        # Add resource-definition script for Windows shared library (.dll).
        configure_file(bsoncxx.rc.in bsoncxx.rc)
        target_sources(bsoncxx_shared PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/bsoncxx.rc)
    endif()
endif()

if(BSONCXX_BUILD_STATIC)
    bsoncxx_add_library(bsoncxx_static "${BSONCXX_OUTPUT_BASENAME}-static" STATIC)
    list(APPEND bsoncxx_target_list bsoncxx_static)
endif()

# Generate and install the export header.
if(1)
    function(bsoncxx_install_export_header TARGET)
        set(bsoncxx_export_header_custom_content "")
        string(APPEND bsoncxx_export_header_custom_content
            "\n"
            "#undef BSONCXX_DEPRECATED_EXPORT\n"
            "#undef BSONCXX_DEPRECATED_NO_EXPORT\n"
            "\n"
            "#if defined(_MSC_VER)\n"
            "#define BSONCXX_ABI_CDECL __cdecl\n"
            "#else\n"
            "#define BSONCXX_ABI_CDECL\n"
            "#endif\n"
            "\n"
            "#define BSONCXX_ABI_EXPORT_CDECL(...) BSONCXX_ABI_EXPORT __VA_ARGS__ BSONCXX_ABI_CDECL\n"
        )
        generate_export_header(${TARGET}
            BASE_NAME BSONCXX_ABI
            EXPORT_MACRO_NAME BSONCXX_ABI_EXPORT
            DEPRECATED_MACRO_NAME BSONCXX_DEPRECATED
            EXPORT_FILE_NAME ${PROJECT_BINARY_DIR}/lib/bsoncxx/v_noabi/bsoncxx/config/export.hpp
            STATIC_DEFINE BSONCXX_STATIC
            CUSTOM_CONTENT_FROM_VARIABLE bsoncxx_export_header_custom_content
        )

        install(FILES
            ${PROJECT_BINARY_DIR}/lib/bsoncxx/v_noabi/bsoncxx/config/export.hpp
            DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/bsoncxx/v_noabi/bsoncxx/config
            COMPONENT dev
        )
    endfunction()

    # Ensure the export header is generated *at most* once.
    # Give priority to the shared library target which sets visibility properties.
    if(BSONCXX_BUILD_SHARED)
        bsoncxx_install_export_header(bsoncxx_shared)
    elseif(BSONCXX_BUILD_STATIC)
        bsoncxx_install_export_header(bsoncxx_static)
    endif()
endif()

add_subdirectory(cmake)

if(ENABLE_TESTS)
    add_subdirectory(test)
endif()

set_local_dist(src_bsoncxx_DIST_local
    CMakeLists.txt
    bsoncxx.rc.in
)

set(src_bsoncxx_DIST
    ${src_bsoncxx_DIST_local}
    ${src_bsoncxx_cmake_DIST}
    ${src_bsoncxx_include_DIST}
    ${src_bsoncxx_lib_DIST}
    ${src_bsoncxx_test_DIST}
    PARENT_SCOPE
)

=== src/mongocxx/CMakeLists.txt ===
# Copyright 2009-present MongoDB, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

project(MONGOCXX)

ParseVersion(${BUILD_VERSION} MONGOCXX)

set(MONGOCXX_VERSION_NO_EXTRA ${MONGOCXX_VERSION_MAJOR}.${MONGOCXX_VERSION_MINOR}.${MONGOCXX_VERSION_PATCH})
set(MONGOCXX_VERSION ${MONGOCXX_VERSION_NO_EXTRA}${MONGOCXX_VERSION_EXTRA})
message(STATUS "mongocxx version: ${MONGOCXX_VERSION}")

option(MONGOCXX_ENABLE_SSL "Enable SSL - if the underlying C driver offers it" ON)
option(MONGOCXX_ENABLE_SLOW_TESTS "Run slow tests when invoking the the test target" OFF)

set(MONGOCXX_OUTPUT_BASENAME "mongocxx" CACHE STRING "Output mongocxx library base name")

set(MONGOCXX_PKG_DEP "") # Required by mongocxx-config.cmake.in.

if(TARGET mongoc_shared OR TARGET mongoc_static)
    # If these targets exist, then libmongoc has already been included as a project
    # sub-directory
    message(STATUS "found libmongoc targets declared in current build scope; version not checked")

    if(NOT MONGOCXX_LINK_WITH_STATIC_MONGOC)
        set(libmongoc_target mongoc_shared)
    else()
        set(libmongoc_target mongoc_static)
    endif()

    set(MONGOCXX_PKG_DEP "find_dependency(mongoc-${LIBMONGOC_REQUIRED_ABI_VERSION} REQUIRED)")
else()
    # Attempt to find libmongoc by new package name (without lib).
    find_package(mongoc-${LIBMONGOC_REQUIRED_ABI_VERSION} ${LIBMONGOC_REQUIRED_VERSION} QUIET)

    if(mongoc-${LIBMONGOC_REQUIRED_ABI_VERSION}_FOUND)
        message(STATUS "found libmongoc version ${mongoc-${LIBMONGOC_REQUIRED_ABI_VERSION}_VERSION}")

        if(NOT MONGOCXX_LINK_WITH_STATIC_MONGOC)
            set(libmongoc_target mongo::mongoc_shared)
        else()
            set(libmongoc_target mongo::mongoc_static)
        endif()

        set(MONGOCXX_PKG_DEP "find_dependency(mongoc-${LIBMONGOC_REQUIRED_ABI_VERSION} REQUIRED)")
    else()
        # Require package of old libmongoc name (with lib).
        if(NOT MONGOCXX_LINK_WITH_STATIC_MONGOC)
            find_package(libmongoc-${LIBMONGOC_REQUIRED_ABI_VERSION} ${LIBMONGOC_REQUIRED_VERSION} REQUIRED)
            message(STATUS "found libmongoc version ${MONGOC_VERSION}")
            set(libmongoc_target ${MONGOC_LIBRARIES})
            set(libmongoc_definitions ${MONGOC_DEFINITIONS})
            set(MONGOCXX_PKG_DEP "find_dependency(libmongoc-${LIBMONGOC_REQUIRED_ABI_VERSION} REQUIRED)")
        else()
            find_package(libmongoc-static-${LIBMONGOC_REQUIRED_ABI_VERSION} ${LIBMONGOC_REQUIRED_VERSION} REQUIRED)
            message(STATUS "found libmongoc version ${MONGOC_STATIC_VERSION}")
            set(libmongoc_target ${MONGOC_STATIC_LIBRARIES})
            set(libmongoc_definitions ${MONGOC_STATIC_DEFINITIONS})
            set(MONGOCXX_PKG_DEP "find_dependency(libmongoc-static-${LIBMONGOC_REQUIRED_ABI_VERSION} REQUIRED)")
        endif()
    endif()
endif()

set(mongocxx_sources "") # Required by mongocxx_add_library().

add_subdirectory(include)
add_subdirectory(lib)

include(MongocxxUtil)

set(mongocxx_target_list "")

if(MONGOCXX_BUILD_SHARED)
    mongocxx_add_library(mongocxx_shared "${MONGOCXX_OUTPUT_BASENAME}" SHARED)
    target_link_libraries(mongocxx_shared PUBLIC bsoncxx_shared)
    list(APPEND mongocxx_target_list mongocxx_shared)

    if(WIN32)
        # Add resource-definition script for Windows shared library (.dll).
        configure_file(mongocxx.rc.in mongocxx.rc)
        target_sources(mongocxx_shared PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/mongocxx.rc)
    endif()
endif()

if(MONGOCXX_BUILD_STATIC)
    mongocxx_add_library(mongocxx_static "${MONGOCXX_OUTPUT_BASENAME}-static" STATIC)
    target_link_libraries(mongocxx_static PUBLIC bsoncxx_static)
    list(APPEND mongocxx_target_list mongocxx_static)
endif()

# Generate and install the export header.
if(1)
    function(mongocxx_install_export_header TARGET)
        set(mongocxx_export_header_custom_content "")
        string(APPEND mongocxx_export_header_custom_content
            "\n"
            "#undef MONGOCXX_DEPRECATED_EXPORT\n"
            "#undef MONGOCXX_DEPRECATED_NO_EXPORT\n"
            "\n"
            "#if defined(_MSC_VER)\n"
            "#define MONGOCXX_ABI_CDECL __cdecl\n"
            "#else\n"
            "#define MONGOCXX_ABI_CDECL\n"
            "#endif\n"
            "\n"
            "#define MONGOCXX_ABI_EXPORT_CDECL(...) MONGOCXX_ABI_EXPORT __VA_ARGS__ MONGOCXX_ABI_CDECL\n"
        )
        generate_export_header(${TARGET}
            BASE_NAME MONGOCXX_ABI
            EXPORT_MACRO_NAME MONGOCXX_ABI_EXPORT
            DEPRECATED_MACRO_NAME MONGOCXX_DEPRECATED
            EXPORT_FILE_NAME ${PROJECT_BINARY_DIR}/lib/mongocxx/v_noabi/mongocxx/config/export.hpp
            STATIC_DEFINE MONGOCXX_STATIC
            CUSTOM_CONTENT_FROM_VARIABLE mongocxx_export_header_custom_content
        )

        install(FILES
            ${PROJECT_BINARY_DIR}/lib/mongocxx/v_noabi/mongocxx/config/export.hpp
            DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/mongocxx/v_noabi/mongocxx/config
            COMPONENT dev
        )
    endfunction()

    # Ensure the export header is generated *at most* once.
    # Give priority to the shared library target which sets visibility properties.
    if(MONGOCXX_BUILD_SHARED)
        mongocxx_install_export_header(mongocxx_shared)
    elseif(MONGOCXX_BUILD_STATIC)
        mongocxx_install_export_header(mongocxx_static)
    endif()
endif()

add_subdirectory(cmake)

if(ENABLE_TESTS)
    add_subdirectory(test)
endif()

set_local_dist(src_mongocxx_DIST_local
    CMakeLists.txt
    mongocxx.rc.in
)

set(src_mongocxx_DIST
    ${src_mongocxx_DIST_local}
    ${src_mongocxx_cmake_DIST}
    ${src_mongocxx_include_DIST}
    ${src_mongocxx_lib_DIST}
    ${src_mongocxx_test_DIST}
    PARENT_SCOPE
)

=== src/bsoncxx/cmake/CMakeLists.txt ===
# Copyright 2009-present MongoDB, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

include(CMakePackageConfigHelpers)

# Generate and install modern CMake package config files.
if(1)
    write_basic_package_version_file(
        bsoncxx-config-version.cmake
        VERSION ${BSONCXX_VERSION}
        COMPATIBILITY SameMajorVersion
    )

    configure_file(
        bsoncxx-config.cmake.in
        bsoncxx-config.cmake
        @ONLY
    )

    install(TARGETS
        ${bsoncxx_target_list}
        EXPORT bsoncxx_targets
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT runtime
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT runtime
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT dev
        INCLUDES DESTINATION
        ${CMAKE_INSTALL_INCLUDEDIR}/bsoncxx/v_noabi
        ${CMAKE_INSTALL_INCLUDEDIR}
    )

    install(EXPORT bsoncxx_targets
        NAMESPACE mongo::
        FILE bsoncxx_targets.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/bsoncxx-${BSONCXX_VERSION}
    )

    install(
        FILES
        ${CMAKE_CURRENT_BINARY_DIR}/bsoncxx-config-version.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/bsoncxx-config.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/bsoncxx-${BSONCXX_VERSION}
        COMPONENT Devel
    )
endif()

# Generate and install pkg-config package config files.
if(1)
    function(bsoncxx_install_pkg_config TARGET LINK_TYPE)
        get_target_property(output_name ${TARGET} OUTPUT_NAME)

        set(pcfilename "${CMAKE_CURRENT_BINARY_DIR}/lib${output_name}.pc")

        if(LINK_TYPE STREQUAL "STATIC")
            set(is_static 1)
        else()
            set(is_static 0)
        endif()

        add_custom_command(
            OUTPUT ${pcfilename}
            COMMAND ${CMAKE_COMMAND}
                -D "src_dir=${CMAKE_CURRENT_SOURCE_DIR}"
                -D "bin_dir=${CMAKE_CURRENT_BINARY_DIR}"
                -D "prefix=${CMAKE_INSTALL_PREFIX}"
                -D "includedir=${CMAKE_INSTALL_INCLUDEDIR}"
                -D "libdir=${CMAKE_INSTALL_LIBDIR}"
                -D "output_name=${output_name}"
                -D "version=${BSONCXX_VERSION_NO_EXTRA}"
                -D "is_static=${is_static}"
                -D "libbson_req_abi_ver=${LIBBSON_REQUIRED_ABI_VERSION}"
                -D "libbson_req_ver=${LIBBSON_REQUIRED_VERSION}"
                -P ${CMAKE_CURRENT_SOURCE_DIR}/generate-pc.cmake
            MAIN_DEPENDENCY
                ${CMAKE_CURRENT_SOURCE_DIR}/libbsoncxx.pc.in
            DEPENDS
                ${CMAKE_CURRENT_SOURCE_DIR}/generate-pc.cmake
        )

        add_custom_target(generate-lib${TARGET}-pc DEPENDS ${pcfilename})
        add_dependencies(${TARGET} generate-lib${TARGET}-pc)

        if(ENABLE_ABI_TAG_IN_PKGCONFIG_FILENAMES)
            install(FILES ${pcfilename} DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
        else()
            if(is_static)
                set(pkgname "lib${BSONCXX_OUTPUT_BASENAME}-static.pc")
            else()
                set(pkgname "lib${BSONCXX_OUTPUT_BASENAME}.pc")
            endif()

            install(
                FILES ${pcfilename}
                DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
                RENAME ${pkgname}
            )
        endif()
    endfunction()

    if(BSONCXX_BUILD_SHARED)
        bsoncxx_install_pkg_config(bsoncxx_shared SHARED)
    endif()

    if(BSONCXX_BUILD_STATIC)
        bsoncxx_install_pkg_config(bsoncxx_static STATIC)
    endif()
endif()

set_dist_list(src_bsoncxx_cmake_DIST
    CMakeLists.txt
    bsoncxx-config.cmake.in
    generate-pc.cmake
    libbsoncxx.pc.in
)

=== src/bsoncxx/include/CMakeLists.txt ===
# Copyright 2009-present MongoDB, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
    COMPONENT dev
    FILES_MATCHING
    PATTERN "*.hpp"
    PATTERN "bsoncxx/doc.hpp" EXCLUDE
)

file(GLOB_RECURSE bsoncxx_include_headers
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
    CONFIGURE_DEPENDS
    "*.hpp"
)

set_dist_list(src_bsoncxx_include_DIST
    CMakeLists.txt
    ${bsoncxx_include_headers}
)

=== src/bsoncxx/lib/CMakeLists.txt ===
# Copyright 2009-present MongoDB, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(bsoncxx_sources_v_noabi
    bsoncxx/v_noabi/bsoncxx/array/element.cpp
    bsoncxx/v_noabi/bsoncxx/array/value.cpp
    bsoncxx/v_noabi/bsoncxx/array/view.cpp
    bsoncxx/v_noabi/bsoncxx/builder/core.cpp
    bsoncxx/v_noabi/bsoncxx/decimal128.cpp
    bsoncxx/v_noabi/bsoncxx/document/element.cpp
    bsoncxx/v_noabi/bsoncxx/document/value.cpp
    bsoncxx/v_noabi/bsoncxx/document/view.cpp
    bsoncxx/v_noabi/bsoncxx/exception/error_code.cpp
    bsoncxx/v_noabi/bsoncxx/exception/exception.cpp
    bsoncxx/v_noabi/bsoncxx/json.cpp
    bsoncxx/v_noabi/bsoncxx/oid.cpp
    bsoncxx/v_noabi/bsoncxx/private/itoa.cpp
    bsoncxx/v_noabi/bsoncxx/string/view_or_value.cpp
    bsoncxx/v_noabi/bsoncxx/types.cpp
    bsoncxx/v_noabi/bsoncxx/types/bson_value/value.cpp
    bsoncxx/v_noabi/bsoncxx/types/bson_value/view.cpp
    bsoncxx/v_noabi/bsoncxx/validate.cpp
)

list(APPEND bsoncxx_sources
    ${bsoncxx_sources_v_noabi}
)
list(TRANSFORM bsoncxx_sources PREPEND "${CMAKE_CURRENT_SOURCE_DIR}/")
set(bsoncxx_sources "${bsoncxx_sources}" PARENT_SCOPE)

# Generate private headers.
if(1)
    configure_file(
        bsoncxx/v_noabi/bsoncxx/config/private/config.hh.in
        bsoncxx/v_noabi/bsoncxx/config/private/config.hh
    )
endif()

# Generate and install public headers.
if(1)
    configure_file(
        bsoncxx/v_noabi/bsoncxx/config/config.hpp.in
        bsoncxx/v_noabi/bsoncxx/config/config.hpp
    )

    configure_file(
        bsoncxx/v_noabi/bsoncxx/config/version.hpp.in
        bsoncxx/v_noabi/bsoncxx/config/version.hpp
    )

    install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/bsoncxx/v_noabi/bsoncxx/config/config.hpp
        ${CMAKE_CURRENT_BINARY_DIR}/bsoncxx/v_noabi/bsoncxx/config/version.hpp
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/bsoncxx/v_noabi/bsoncxx/config
        COMPONENT dev
    )
endif()

set_dist_list(src_bsoncxx_lib_DIST
    CMakeLists.txt
    ${bsoncxx_sources_v_noabi}
    bsoncxx/v_noabi/bsoncxx/config/config.hpp.in
    bsoncxx/v_noabi/bsoncxx/config/private/config.hh.in
    bsoncxx/v_noabi/bsoncxx/config/private/postlude.hh
    bsoncxx/v_noabi/bsoncxx/config/private/prelude.hh
    bsoncxx/v_noabi/bsoncxx/config/version.hpp.in
    bsoncxx/v_noabi/bsoncxx/private/b64_ntop.hh
    bsoncxx/v_noabi/bsoncxx/private/helpers.hh
    bsoncxx/v_noabi/bsoncxx/private/make_unique.hh
    bsoncxx/v_noabi/bsoncxx/private/itoa.hh
    bsoncxx/v_noabi/bsoncxx/private/libbson.hh
    bsoncxx/v_noabi/bsoncxx/private/stack.hh
    bsoncxx/v_noabi/bsoncxx/private/suppress_deprecation_warnings.hh
    bsoncxx/v_noabi/bsoncxx/test_util/export_for_testing.hh
    bsoncxx/v_noabi/bsoncxx/types/bson_value/private/value.hh
    bsoncxx/v_noabi/bsoncxx/types/private/convert.hh
)

=== src/bsoncxx/test/CMakeLists.txt ===
# Copyright 2009-present MongoDB, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

include(FetchCatch2)

if(NOT BUILD_TESTING)
    set_property(DIRECTORY PROPERTY EXCLUDE_FROM_ALL TRUE)
endif()

if(BSONCXX_BUILD_SHARED)
    bsoncxx_add_library(bsoncxx_testing "bsoncxx-testing" SHARED)
else()
    bsoncxx_add_library(bsoncxx_testing "bsoncxx-testing" STATIC)
endif()

target_compile_definitions(bsoncxx_testing PUBLIC BSONCXX_TESTING)

add_executable(test_bson
    array.cpp
    bson_b_date.cpp
    bson_builder.cpp
    bson_get_values.cpp
    bson_serialization.cpp
    bson_types.cpp
    bson_util_itoa.cpp
    bson_validate.cpp
    bson_value.cpp
    catch.cpp
    exception_guard.cpp
    json.cpp
    oid.cpp
    optional.test.cpp
    view_or_value.cpp
    make_unique.test.cpp
    string_view.test.cpp
    type_traits.test.cpp
)

# Common target properties for test executables.
add_library(bsoncxx_test_properties INTERFACE)

target_link_libraries(bsoncxx_test_properties INTERFACE Catch2::Catch2)
target_compile_features(bsoncxx_test_properties INTERFACE cxx_std_14)

target_link_libraries(bsoncxx_test_properties INTERFACE bsoncxx_testing ${libbson_target})
target_include_directories(bsoncxx_test_properties INTERFACE

    # Allow `#include <bson/bson.h>`
    ${libbson_include_directories}

    # Allow `#include <bsoncxx/test/...>`.
    ${CMAKE_CURRENT_SOURCE_DIR}/../..
)
target_compile_definitions(bsoncxx_test_properties INTERFACE ${libbson_definitions})
# Use `__vectorcall` by default with MSVC to catch missing `__cdecl`.
target_compile_options(bsoncxx_test_properties INTERFACE "$<$<CXX_COMPILER_ID:MSVC>:/Gv>")
add_library(bsoncxx::test_properties ALIAS bsoncxx_test_properties)

# Avoid redundant recompilation of catch/main.cpp.
add_library(bsoncxx_test_properties_with_main INTERFACE)
target_link_libraries(bsoncxx_test_properties_with_main INTERFACE bsoncxx::test_properties)
target_sources(bsoncxx_test_properties INTERFACE catch.cpp)
add_library(bsoncxx::test_properties_with_main ALIAS bsoncxx_test_properties_with_main)

target_link_libraries (test_bson PRIVATE bsoncxx::test_properties_with_main)

add_test(NAME bson COMMAND test_bson --reporter compact --allow-running-no-tests)

# Generate test to ensure macro guards behave properly.
if(ENABLE_MACRO_GUARD_TESTS)
    include(MacroGuardTest)

    add_macro_guard_test(
        PROJECT_NAME bsoncxx
        PROJECT_TEST_PROPERTIES_TARGET bsoncxx::test_properties
        GUARDED_MACROS
            # config.hpp (generated by CMake)
            BSONCXX_POLY_USE_IMPLS
            BSONCXX_POLY_USE_STD

            # version.hpp (generated by CMake)
            BSONCXX_VERSION_EXTRA
            BSONCXX_VERSION_MAJOR
            BSONCXX_VERSION_MINOR
            BSONCXX_VERSION_PATCH

            # export.hpp (generated by CMake)
            BSONCXX_ABI_CDECL
            BSONCXX_ABI_EXPORT
            BSONCXX_ABI_EXPORT_TESTING
            BSONCXX_ABI_NO_EXPORT
            BSONCXX_ABI_EXPORT_CDECL
            BSONCXX_ABI_EXPORT_CDECL_TESTING
            BSONCXX_DEPRECATED

            # prelude.hpp
            BSONCXX_UNREACHABLE

            # util.hpp
            _bsoncxxDisableWarningImpl_for_GCC
            _bsoncxxDisableWarningImpl_for_GNU
            _bsoncxxDisableWarningImpl_for_MSVC
            _bsoncxxDisableWarningImpl_for_Clang
            BSONCXX_PUSH_WARNINGS
            BSONCXX_POP_WARNINGS
            BSONCXX_DISABLE_WARNING
            BSONCXX_CONCAT
            BSONCXX_CONCAT_IMPL
            bsoncxx_cxx14_constexpr
            BSONCXX_FORCE_SEMICOLON
            BSONCXX_FWD
            BSONCXX_PRAGMA
            _bsoncxxPragma
            BSONCXX_STRINGIFY
            BSONCXX_STRINGIFY_IMPL
            BSONCXX_IF_MSVC
            BSONCXX_IF_GCC
            BSONCXX_IF_CLANG
            BSONCXX_IF_GNU_LIKE
            BSONCXX_RETURNS
        INCLUDE_PATTERNS
            "include/*.hpp" # Public headers.
        EXCLUDE_REGEXES
            "include/bsoncxx/doc\.hpp" # Doc header.
            "include/.*/(prelude|postlude)\.hpp" # Macro guard headers.
            "include/bsoncxx/v_noabi/bsoncxx/config/.*\.hpp" # v_noabi config headers.
            "include/bsoncxx/v_noabi/bsoncxx/enums/.*\.hpp" # v_noabi X-macro headers.
    )
endif()

set_dist_list(src_bsoncxx_test_DIST
    CMakeLists.txt
    array.cpp
    bson_b_date.cpp
    bson_builder.cpp
    bson_get_values.cpp
    bson_serialization.cpp
    bson_types.cpp
    bson_util_itoa.cpp
    bson_validate.cpp
    bson_value.cpp
    catch.cpp
    catch.hh
    exception_guard.cpp
    exception_guard.hh
    json.cpp
    oid.cpp
    optional.test.cpp
    test_macro_guards.cpp.in
    to_string.hh
    view_or_value.cpp
    make_unique.test.cpp
    string_view.test.cpp
    type_traits.test.cpp
)

=== src/mongocxx/cmake/CMakeLists.txt ===
# Copyright 2009-present MongoDB, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

include(CMakePackageConfigHelpers)

# Generate and install modern CMake package config files.
if(1)
    write_basic_package_version_file(
        mongocxx-config-version.cmake
        VERSION ${MONGOCXX_VERSION}
        COMPATIBILITY SameMajorVersion
    )

    configure_file(
        mongocxx-config.cmake.in
        mongocxx-config.cmake
        @ONLY
    )

    install(TARGETS
        ${mongocxx_target_list}
        EXPORT mongocxx_targets
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT runtime
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT runtime
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT dev
        INCLUDES DESTINATION
        ${CMAKE_INSTALL_INCLUDEDIR}/mongocxx/v_noabi
        ${CMAKE_INSTALL_INCLUDEDIR}
    )

    install(EXPORT mongocxx_targets
        NAMESPACE mongo::
        FILE mongocxx_targets.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/mongocxx-${MONGOCXX_VERSION}
    )

    install(
        FILES
        ${CMAKE_CURRENT_BINARY_DIR}/mongocxx-config-version.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/mongocxx-config.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/mongocxx-${MONGOCXX_VERSION}
        COMPONENT Devel
    )
endif()

# Generate and install pkg-config package config files.
if(1)
    function(mongocxx_install_pkg_config TARGET LINK_TYPE)
        get_target_property(output_name ${TARGET} OUTPUT_NAME)

        set(pcfilename "${CMAKE_CURRENT_BINARY_DIR}/lib${output_name}.pc")

        if (ENABLE_ABI_TAG_IN_PKGCONFIG_FILENAMES)
            if(LINK_TYPE STREQUAL "STATIC")
                get_target_property(bsoncxx_name bsoncxx_static OUTPUT_NAME)
                set(is_static 1)
            else()
                get_target_property(bsoncxx_name bsoncxx_shared OUTPUT_NAME)
                set(is_static 0)
            endif()
        else()
            if(LINK_TYPE STREQUAL "STATIC")
                set(bsoncxx_name "$CACHE{BSONCXX_OUTPUT_BASENAME}-static")
                set(is_static 1)
            else()
                set(bsoncxx_name "$CACHE{BSONCXX_OUTPUT_BASENAME}")
                set(is_static 0)
            endif()
        endif()

        add_custom_command(
            OUTPUT ${pcfilename}
            COMMAND ${CMAKE_COMMAND}
                -D "src_dir=${CMAKE_CURRENT_SOURCE_DIR}"
                -D "bin_dir=${CMAKE_CURRENT_BINARY_DIR}"
                -D "prefix=${CMAKE_INSTALL_PREFIX}"
                -D "includedir=${CMAKE_INSTALL_INCLUDEDIR}"
                -D "libdir=${CMAKE_INSTALL_LIBDIR}"
                -D "output_name=${output_name}"
                -D "version=${MONGOCXX_VERSION_NO_EXTRA}"
                -D "is_static=${is_static}"
                -D "bsoncxx_name=${bsoncxx_name}"
                -D "libmongoc_req_abi_ver=${LIBMONGOC_REQUIRED_ABI_VERSION}"
                -D "libmongoc_req_ver=${LIBMONGOC_REQUIRED_VERSION}"
                -P ${CMAKE_CURRENT_SOURCE_DIR}/generate-pc.cmake
            MAIN_DEPENDENCY
                ${CMAKE_CURRENT_SOURCE_DIR}/libmongocxx.pc.in
            DEPENDS
                ${CMAKE_CURRENT_SOURCE_DIR}/generate-pc.cmake
        )

        add_custom_target(generate-lib${TARGET}-pc DEPENDS ${pcfilename})
        add_dependencies(${TARGET} generate-lib${TARGET}-pc)

        if(ENABLE_ABI_TAG_IN_PKGCONFIG_FILENAMES)
            install(FILES ${pcfilename} DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
        else()
            if(is_static)
                set(pkgname "lib${MONGOCXX_OUTPUT_BASENAME}-static.pc")
            else()
                set(pkgname "lib${MONGOCXX_OUTPUT_BASENAME}.pc")
            endif()

            install(
                FILES ${pcfilename}
                DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
                RENAME ${pkgname}
            )
        endif()
    endfunction()

    if(MONGOCXX_BUILD_SHARED)
        mongocxx_install_pkg_config(mongocxx_shared SHARED)
    endif()

    if(MONGOCXX_BUILD_STATIC)
        mongocxx_install_pkg_config(mongocxx_static STATIC)
    endif()
endif()

set_dist_list(src_mongocxx_cmake_DIST
    CMakeLists.txt
    generate-pc.cmake
    libmongocxx.pc.in
    mongocxx-config.cmake.in
)

=== src/mongocxx/include/CMakeLists.txt ===
# Copyright 2009-present MongoDB, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
    COMPONENT dev
    FILES_MATCHING
    PATTERN "*.hpp"
    PATTERN "mongocxx/doc.hpp" EXCLUDE
)

file(GLOB_RECURSE mongocxx_include_headers
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
    CONFIGURE_DEPENDS
    "*.hpp"
)

set_dist_list(src_mongocxx_include_DIST
    CMakeLists.txt
    ${mongocxx_include_headers}
)

=== src/mongocxx/lib/CMakeLists.txt ===
# Copyright 2009-present MongoDB, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(mongocxx_sources_v_noabi
    mongocxx/v_noabi/mongocxx/bulk_write.cpp
    mongocxx/v_noabi/mongocxx/change_stream.cpp
    mongocxx/v_noabi/mongocxx/client_encryption.cpp
    mongocxx/v_noabi/mongocxx/client_session.cpp
    mongocxx/v_noabi/mongocxx/client.cpp
    mongocxx/v_noabi/mongocxx/collection.cpp
    mongocxx/v_noabi/mongocxx/cursor.cpp
    mongocxx/v_noabi/mongocxx/database.cpp
    mongocxx/v_noabi/mongocxx/events/command_failed_event.cpp
    mongocxx/v_noabi/mongocxx/events/command_started_event.cpp
    mongocxx/v_noabi/mongocxx/events/command_succeeded_event.cpp
    mongocxx/v_noabi/mongocxx/events/heartbeat_failed_event.cpp
    mongocxx/v_noabi/mongocxx/events/heartbeat_started_event.cpp
    mongocxx/v_noabi/mongocxx/events/heartbeat_succeeded_event.cpp
    mongocxx/v_noabi/mongocxx/events/server_changed_event.cpp
    mongocxx/v_noabi/mongocxx/events/server_closed_event.cpp
    mongocxx/v_noabi/mongocxx/events/server_description.cpp
    mongocxx/v_noabi/mongocxx/events/server_opening_event.cpp
    mongocxx/v_noabi/mongocxx/events/topology_changed_event.cpp
    mongocxx/v_noabi/mongocxx/events/topology_closed_event.cpp
    mongocxx/v_noabi/mongocxx/events/topology_description.cpp
    mongocxx/v_noabi/mongocxx/events/topology_opening_event.cpp
    mongocxx/v_noabi/mongocxx/exception/authentication_exception.cpp
    mongocxx/v_noabi/mongocxx/exception/bulk_write_exception.cpp
    mongocxx/v_noabi/mongocxx/exception/error_code.cpp
    mongocxx/v_noabi/mongocxx/exception/exception.cpp
    mongocxx/v_noabi/mongocxx/exception/gridfs_exception.cpp
    mongocxx/v_noabi/mongocxx/exception/logic_error.cpp
    mongocxx/v_noabi/mongocxx/exception/operation_exception.cpp
    mongocxx/v_noabi/mongocxx/exception/query_exception.cpp
    mongocxx/v_noabi/mongocxx/exception/server_error_code.cpp
    mongocxx/v_noabi/mongocxx/exception/write_exception.cpp
    mongocxx/v_noabi/mongocxx/gridfs/bucket.cpp
    mongocxx/v_noabi/mongocxx/gridfs/downloader.cpp
    mongocxx/v_noabi/mongocxx/gridfs/uploader.cpp
    mongocxx/v_noabi/mongocxx/hint.cpp
    mongocxx/v_noabi/mongocxx/index_model.cpp
    mongocxx/v_noabi/mongocxx/index_view.cpp
    mongocxx/v_noabi/mongocxx/instance.cpp
    mongocxx/v_noabi/mongocxx/logger.cpp
    mongocxx/v_noabi/mongocxx/model/delete_many.cpp
    mongocxx/v_noabi/mongocxx/model/delete_one.cpp
    mongocxx/v_noabi/mongocxx/model/insert_one.cpp
    mongocxx/v_noabi/mongocxx/model/replace_one.cpp
    mongocxx/v_noabi/mongocxx/model/update_many.cpp
    mongocxx/v_noabi/mongocxx/model/update_one.cpp
    mongocxx/v_noabi/mongocxx/model/write.cpp
    mongocxx/v_noabi/mongocxx/options/aggregate.cpp
    mongocxx/v_noabi/mongocxx/options/apm.cpp
    mongocxx/v_noabi/mongocxx/options/auto_encryption.cpp
    mongocxx/v_noabi/mongocxx/options/bulk_write.cpp
    mongocxx/v_noabi/mongocxx/options/change_stream.cpp
    mongocxx/v_noabi/mongocxx/options/client_encryption.cpp
    mongocxx/v_noabi/mongocxx/options/client_session.cpp
    mongocxx/v_noabi/mongocxx/options/client.cpp
    mongocxx/v_noabi/mongocxx/options/count.cpp
    mongocxx/v_noabi/mongocxx/options/data_key.cpp
    mongocxx/v_noabi/mongocxx/options/delete.cpp
    mongocxx/v_noabi/mongocxx/options/distinct.cpp
    mongocxx/v_noabi/mongocxx/options/encrypt.cpp
    mongocxx/v_noabi/mongocxx/options/estimated_document_count.cpp
    mongocxx/v_noabi/mongocxx/options/find_one_and_delete.cpp
    mongocxx/v_noabi/mongocxx/options/find_one_and_replace.cpp
    mongocxx/v_noabi/mongocxx/options/find_one_and_update.cpp
    mongocxx/v_noabi/mongocxx/options/find.cpp
    mongocxx/v_noabi/mongocxx/options/gridfs/bucket.cpp
    mongocxx/v_noabi/mongocxx/options/gridfs/upload.cpp
    mongocxx/v_noabi/mongocxx/options/index_view.cpp
    mongocxx/v_noabi/mongocxx/options/index.cpp
    mongocxx/v_noabi/mongocxx/options/insert.cpp
    mongocxx/v_noabi/mongocxx/options/pool.cpp
    mongocxx/v_noabi/mongocxx/options/range.cpp
    mongocxx/v_noabi/mongocxx/options/replace.cpp
    mongocxx/v_noabi/mongocxx/options/rewrap_many_datakey.cpp
    mongocxx/v_noabi/mongocxx/options/server_api.cpp
    mongocxx/v_noabi/mongocxx/options/tls.cpp
    mongocxx/v_noabi/mongocxx/options/transaction.cpp
    mongocxx/v_noabi/mongocxx/options/update.cpp
    mongocxx/v_noabi/mongocxx/pipeline.cpp
    mongocxx/v_noabi/mongocxx/pool.cpp
    mongocxx/v_noabi/mongocxx/private/conversions.cpp
    mongocxx/v_noabi/mongocxx/private/libbson.cpp
    mongocxx/v_noabi/mongocxx/private/libmongoc.cpp
    mongocxx/v_noabi/mongocxx/private/numeric_casting.cpp
    mongocxx/v_noabi/mongocxx/read_concern.cpp
    mongocxx/v_noabi/mongocxx/read_preference.cpp
    mongocxx/v_noabi/mongocxx/result/bulk_write.cpp
    mongocxx/v_noabi/mongocxx/result/delete.cpp
    mongocxx/v_noabi/mongocxx/result/gridfs/upload.cpp
    mongocxx/v_noabi/mongocxx/result/insert_many.cpp
    mongocxx/v_noabi/mongocxx/result/insert_one.cpp
    mongocxx/v_noabi/mongocxx/result/replace_one.cpp
    mongocxx/v_noabi/mongocxx/result/rewrap_many_datakey.cpp
    mongocxx/v_noabi/mongocxx/result/update.cpp
    mongocxx/v_noabi/mongocxx/search_index_model.cpp
    mongocxx/v_noabi/mongocxx/search_index_view.cpp
    mongocxx/v_noabi/mongocxx/uri.cpp
    mongocxx/v_noabi/mongocxx/validation_criteria.cpp
    mongocxx/v_noabi/mongocxx/write_concern.cpp
)

list(APPEND mongocxx_sources
    ${mongocxx_sources_v_noabi}
)
list(TRANSFORM mongocxx_sources PREPEND "${CMAKE_CURRENT_SOURCE_DIR}/")
set(mongocxx_sources "${mongocxx_sources}" PARENT_SCOPE)

# Generate private headers.
if(1)
    if(DEFINED CMAKE_CXX_COMPILER_ID)
        set(MONGOCXX_COMPILER_ID "${CMAKE_CXX_COMPILER_ID}")
    else()
        set(MONGOCXX_COMPILER_ID "Unknown")
    endif()

    if(DEFINED CMAKE_CXX_COMPILER_VERSION)
        set(MONGOCXX_COMPILER_VERSION "${CMAKE_CXX_COMPILER_VERSION}")
    else()
        set(MONGOCXX_COMPILER_VERSION "Unknown")
    endif()

    configure_file(
        mongocxx/v_noabi/mongocxx/config/private/config.hh.in
        mongocxx/v_noabi/mongocxx/config/private/config.hh
    )
endif()

# Generate and install public headers.
if(1)
    configure_file(
        mongocxx/v_noabi/mongocxx/config/version.hpp.in
        mongocxx/v_noabi/mongocxx/config/version.hpp
    )

    configure_file(
        mongocxx/v_noabi/mongocxx/config/config.hpp.in
        mongocxx/v_noabi/mongocxx/config/config.hpp
    )

    install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/mongocxx/v_noabi/mongocxx/config/config.hpp
        ${CMAKE_CURRENT_BINARY_DIR}/mongocxx/v_noabi/mongocxx/config/version.hpp
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/mongocxx/v_noabi/mongocxx/config
        COMPONENT dev
    )
endif()

set_dist_list(src_mongocxx_lib_DIST
    CMakeLists.txt
    ${mongocxx_sources_v_noabi}
    mongocxx/v_noabi/mongocxx/config/config.hpp.in
    mongocxx/v_noabi/mongocxx/config/private/config.hh.in
    mongocxx/v_noabi/mongocxx/config/private/postlude.hh
    mongocxx/v_noabi/mongocxx/config/private/prelude.hh
    mongocxx/v_noabi/mongocxx/config/version.hpp.in
    mongocxx/v_noabi/mongocxx/exception/private/mongoc_error.hh
    mongocxx/v_noabi/mongocxx/gridfs/private/bucket.hh
    mongocxx/v_noabi/mongocxx/gridfs/private/downloader.hh
    mongocxx/v_noabi/mongocxx/gridfs/private/uploader.hh
    mongocxx/v_noabi/mongocxx/options/private/apm.hh
    mongocxx/v_noabi/mongocxx/options/private/server_api.hh
    mongocxx/v_noabi/mongocxx/options/private/ssl.hh
    mongocxx/v_noabi/mongocxx/options/private/transaction.hh
    mongocxx/v_noabi/mongocxx/private/append_aggregate_options.hh
    mongocxx/v_noabi/mongocxx/private/bulk_write.hh
    mongocxx/v_noabi/mongocxx/private/change_stream.hh
    mongocxx/v_noabi/mongocxx/private/client_encryption.hh
    mongocxx/v_noabi/mongocxx/private/client_session.hh
    mongocxx/v_noabi/mongocxx/private/client.hh
    mongocxx/v_noabi/mongocxx/private/collection.hh
    mongocxx/v_noabi/mongocxx/private/conversions.hh
    mongocxx/v_noabi/mongocxx/private/cursor.hh
    mongocxx/v_noabi/mongocxx/private/database.hh
    mongocxx/v_noabi/mongocxx/private/index_view.hh
    mongocxx/v_noabi/mongocxx/private/libbson.hh
    mongocxx/v_noabi/mongocxx/private/libmongoc_symbols.hh
    mongocxx/v_noabi/mongocxx/private/libmongoc.hh
    mongocxx/v_noabi/mongocxx/private/numeric_casting.hh
    mongocxx/v_noabi/mongocxx/private/pipeline.hh
    mongocxx/v_noabi/mongocxx/private/pool.hh
    mongocxx/v_noabi/mongocxx/private/read_concern.hh
    mongocxx/v_noabi/mongocxx/private/read_preference.hh
    mongocxx/v_noabi/mongocxx/private/scoped_bson_value.hh
    mongocxx/v_noabi/mongocxx/private/search_index_model.hh
    mongocxx/v_noabi/mongocxx/private/search_index_view.hh
    mongocxx/v_noabi/mongocxx/private/uri.hh
    mongocxx/v_noabi/mongocxx/private/write_concern.hh
    mongocxx/v_noabi/mongocxx/test_util/export_for_testing.hh
    mongocxx/v_noabi/mongocxx/test_util/mock.hh
)

=== src/mongocxx/test/CMakeLists.txt ===
# Copyright 2009-present MongoDB, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

include(FetchCatch2)

if(NOT BUILD_TESTING)
    set_property(DIRECTORY PROPERTY EXCLUDE_FROM_ALL TRUE)
endif()

if(MONGOCXX_BUILD_SHARED)
    mongocxx_add_library(mongocxx_mocked "mongocxx-mocked" SHARED)
else()
    mongocxx_add_library(mongocxx_mocked "mongocxx-mocked" STATIC)
endif()

target_link_libraries(mongocxx_mocked PUBLIC bsoncxx_testing)
target_compile_definitions(mongocxx_mocked PUBLIC MONGOCXX_TESTING)

if(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_compile_options(mongocxx_mocked PRIVATE /bigobj)
endif()

add_library(client_helpers OBJECT client_helpers.cpp)

add_library(spec_test_common OBJECT
    spec/monitoring.cpp
    spec/operation.cpp
    spec/unified_tests/assert.cpp
    spec/unified_tests/entity.cpp
    spec/util.cpp
)

add_executable(test_driver
    bulk_write.cpp
    catch_helpers.cpp
    change_streams.cpp
    client_session.cpp
    client_side_encryption.cpp
    client.cpp
    collection_mocked.cpp
    collection.cpp
    conversions.cpp
    database.cpp
    gridfs/bucket.cpp
    gridfs/downloader.cpp
    gridfs/uploader.cpp
    hint.cpp
    index_view.cpp
    model/delete_many.cpp
    model/delete_one.cpp
    model/insert_one.cpp
    model/replace_one.cpp
    model/update_many.cpp
    model/update_one.cpp
    options/aggregate.cpp
    options/bulk_write.cpp
    options/client_session.cpp
    options/count.cpp
    options/delete.cpp
    options/distinct.cpp
    options/find_one_and_delete.cpp
    options/find_one_and_replace.cpp
    options/find_one_and_update.cpp
    options/find.cpp
    options/gridfs/bucket.cpp
    options/gridfs/upload.cpp
    options/index.cpp
    options/insert.cpp
    options/pool.cpp
    options/replace.cpp
    options/update.cpp
    pool.cpp
    private/numeric_casting.cpp
    private/scoped_bson_t.cpp
    private/write_concern.cpp
    read_concern.cpp
    read_preference.cpp
    result/bulk_write.cpp
    result/delete.cpp
    result/gridfs/upload.cpp
    result/insert_one.cpp
    result/replace_one.cpp
    result/update.cpp
    sdam-monitoring.cpp
    search_index_view.cpp
    spec/initial_dns_seedlist_discovery.cpp
    spec/monitoring.cpp
    spec/monitoring.hh
    spec/unified_tests/assert.cpp
    spec/unified_tests/entity.cpp
    spec/uri_options.cpp
    transactions.cpp
    uri.cpp
    validation_criteria.cpp
    write_concern.cpp
)
target_link_libraries(test_driver PRIVATE client_helpers)

add_executable(test_logging logging.cpp)

add_executable(test_instance instance.cpp)

add_executable(test_crud_specs spec/crud.cpp)
target_link_libraries(test_crud_specs PRIVATE spec_test_common client_helpers)

add_executable(test_gridfs_specs spec/gridfs.cpp)
target_link_libraries(test_gridfs_specs PRIVATE spec_test_common client_helpers)

add_executable(test_client_side_encryption_specs spec/client_side_encryption.cpp)
target_link_libraries(test_client_side_encryption_specs PRIVATE spec_test_common client_helpers)

add_executable(test_command_monitoring_specs spec/command_monitoring.cpp)
target_link_libraries(test_command_monitoring_specs PRIVATE spec_test_common client_helpers)

add_executable(test_transactions_specs spec/transactions.cpp)
target_link_libraries(test_transactions_specs PRIVATE spec_test_common client_helpers)

add_executable(test_retryable_reads_specs spec/retryable-reads.cpp)
target_link_libraries(test_retryable_reads_specs PRIVATE spec_test_common client_helpers)

add_executable(test_read_write_concern_specs spec/read_write_concern.cpp)
target_link_libraries(test_read_write_concern_specs PRIVATE spec_test_common client_helpers)

add_executable(test_mongohouse_specs spec/mongohouse.cpp)
target_link_libraries(test_mongohouse_specs PRIVATE spec_test_common client_helpers)

add_executable(test_unified_format_specs spec/unified_tests/operations.cpp spec/unified_tests/runner.cpp)
target_link_libraries(test_unified_format_specs PRIVATE spec_test_common client_helpers)

add_executable(test_versioned_api versioned_api.cpp)
target_link_libraries(test_versioned_api PRIVATE spec_test_common client_helpers)

# Common target properties for test executables.
add_library(mongocxx_test_properties INTERFACE)

target_link_libraries(mongocxx_test_properties INTERFACE Catch2::Catch2)
target_compile_features(mongocxx_test_properties INTERFACE cxx_std_14)

target_link_libraries(mongocxx_test_properties INTERFACE mongocxx_mocked ${libmongoc_target})
target_include_directories(mongocxx_test_properties INTERFACE

    # Allow `#include <mongoc/mongoc.h>`
    ${libmongoc_include_directories}

    # Allow `#include <mongocxx/test/...>`.
    ${CMAKE_CURRENT_SOURCE_DIR}/../..
)
# Use `__vectorcall` by default with MSVC to catch missing `__cdecl`.
target_compile_options(mongocxx_test_properties INTERFACE "$<$<CXX_COMPILER_ID:MSVC>:/Gv>")
add_library(mongocxx::test_properties ALIAS mongocxx_test_properties)

add_library(mongocxx_test_properties_with_main INTERFACE)
target_link_libraries(mongocxx_test_properties_with_main INTERFACE mongocxx::test_properties)
target_sources(mongocxx_test_properties_with_main INTERFACE catch.cpp)
add_library(mongocxx::test_properties_with_main ALIAS mongocxx_test_properties_with_main)

set_property(
    TARGET
        client_helpers
        spec_test_common
    APPEND PROPERTY LINK_LIBRARIES
        mongocxx::test_properties
)

set_property(
    TARGET
        test_client_side_encryption_specs
        test_command_monitoring_specs
        test_crud_specs
        test_driver
        test_gridfs_specs
        test_instance
        test_logging
        test_mongohouse_specs
        test_read_write_concern_specs
        test_retryable_reads_specs
        test_transactions_specs
        test_unified_format_specs
        test_versioned_api
    APPEND PROPERTY LINK_LIBRARIES
        mongocxx::test_properties_with_main
)

target_compile_definitions(test_driver PRIVATE ${libmongoc_definitions})
target_compile_definitions(test_logging PRIVATE ${libmongoc_definitions})
target_compile_definitions(test_instance PRIVATE ${libmongoc_definitions})

if(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_compile_options(test_driver PRIVATE /bigobj)
endif()

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_compile_options(test_driver PRIVATE -Wno-maybe-uninitialized)
    target_compile_options(test_retryable_reads_specs PRIVATE -Wno-maybe-uninitialized)
endif()

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
target_link_libraries(test_driver PRIVATE Threads::Threads)

foreach(test_name
    client_side_encryption_specs
    command_monitoring_specs
    crud_specs
    driver
    gridfs_specs
    instance
    logging
    read_write_concern_specs
    retryable_reads_specs
    transactions_specs
    unified_format_specs
    versioned_api
)
    add_test(NAME ${test_name} COMMAND test_${test_name} --reporter compact --allow-running-no-tests)
endforeach()

# Adding this as a test will run it as part of the RUN_TESTS command in MSVC.
# Do not add, since we only test mongohouse on Linux.
if(0)
    add_test(NAME mongohouse_specs COMMAND test_mongohouse_specs ${test_args})
endif()

set_property(TEST crud_specs APPEND PROPERTY ENVIRONMENT
    "CRUD_LEGACY_TESTS_PATH=${DATA_SOURCE_DIR}/crud/legacy"
)

set_property(TEST gridfs_specs APPEND PROPERTY ENVIRONMENT
    "GRIDFS_TESTS_PATH=${DATA_SOURCE_DIR}/gridfs"
)

set_property(TEST client_side_encryption_specs APPEND PROPERTY ENVIRONMENT
    "CLIENT_SIDE_ENCRYPTION_LEGACY_TESTS_PATH=${DATA_SOURCE_DIR}/client_side_encryption/legacy"
)

set_property(TEST driver APPEND PROPERTY ENVIRONMENT
    "CLIENT_SIDE_ENCRYPTION_TESTS_PATH=${DATA_SOURCE_DIR}/client_side_encryption"
    "URI_OPTIONS_TESTS_PATH=${DATA_SOURCE_DIR}/uri-options"
)

set_property(TEST command_monitoring_specs APPEND PROPERTY ENVIRONMENT
    "COMMAND_MONITORING_TESTS_PATH=${DATA_SOURCE_DIR}/command-monitoring"
)

set_property(TEST transactions_specs APPEND PROPERTY ENVIRONMENT
    "TRANSACTIONS_LEGACY_TESTS_PATH=${DATA_SOURCE_DIR}/transactions/legacy"
    "WITH_TRANSACTION_TESTS_PATH=${DATA_SOURCE_DIR}/with_transaction"
)

set_property(TEST retryable_reads_specs APPEND PROPERTY ENVIRONMENT
    "RETRYABLE_READS_LEGACY_TESTS_PATH=${DATA_SOURCE_DIR}/retryable-reads/legacy"
)

set_property(TEST read_write_concern_specs APPEND PROPERTY ENVIRONMENT
    "READ_WRITE_CONCERN_OPERATION_TESTS_PATH=${DATA_SOURCE_DIR}/read-write-concern/operation"
)

set_property(TEST unified_format_specs APPEND PROPERTY ENVIRONMENT
    "CHANGE_STREAMS_UNIFIED_TESTS_PATH=${DATA_SOURCE_DIR}/change-streams/unified"
    "CLIENT_SIDE_ENCRYPTION_UNIFIED_TESTS_PATH=${DATA_SOURCE_DIR}/client_side_encryption/unified"
    "COLLECTION_MANAGEMENT_TESTS_PATH=${DATA_SOURCE_DIR}/collection-management"
    "CRUD_UNIFIED_TESTS_PATH=${DATA_SOURCE_DIR}/crud/unified"
    "INDEX_MANAGEMENT_TESTS_PATH=${DATA_SOURCE_DIR}/index-management"
    "RETRYABLE_READS_UNIFIED_TESTS_PATH=${DATA_SOURCE_DIR}/retryable-reads/unified/"
    "RETRYABLE_WRITES_UNIFIED_TESTS_PATH=${DATA_SOURCE_DIR}/retryable-writes/unified/"
    "SESSION_UNIFIED_TESTS_PATH=${DATA_SOURCE_DIR}/sessions/unified/"
    "TRANSACTIONS_UNIFIED_TESTS_PATH=${DATA_SOURCE_DIR}/transactions/unified"
    "UNIFIED_FORMAT_TESTS_PATH=${DATA_SOURCE_DIR}/unified-format"
    "VERSIONED_API_TESTS_PATH=${DATA_SOURCE_DIR}/versioned-api"
)

if(MONGOCXX_ENABLE_SLOW_TESTS)
    set_property(TEST driver APPEND PROPERTY ENVIRONMENT "MONGOCXX_ENABLE_SLOW_TESTS=1")
endif()

# Generate test to ensure macro guards behave properly.
if(ENABLE_MACRO_GUARD_TESTS)
    include(MacroGuardTest)

    add_macro_guard_test(
        PROJECT_NAME mongocxx
        PROJECT_TEST_PROPERTIES_TARGET mongocxx::test_properties
        GUARDED_MACROS
            # version.hpp (generated by CMake)
            MONGOCXX_VERSION_STRING
            MONGOCXX_VERSION_EXTRA
            MONGOCXX_VERSION_MAJOR
            MONGOCXX_VERSION_MINOR
            MONGOCXX_VERSION_PATCH

            # export.hpp (generated by CMake)
            MONGOCXX_ABI_CDECL
            MONGOCXX_ABI_EXPORT
            MONGOCXX_ABI_EXPORT_TESTING
            MONGOCXX_ABI_EXPORT_CDECL
            MONGOCXX_ABI_EXPORT_CDECL_TESTING
            MONGOCXX_ABI_NO_EXPORT
            MONGOCXX_DEPRECATED

            # prelude.hpp
            MONGOCXX_UNREACHABLE

            # config.hh (generated by CMake)
            MONGOCXX_ENABLE_SSL
            MONGOCXX_COMPILER_ID
            MONGOCXX_COMPILER_VERSION
        INCLUDE_PATTERNS
            "include/*.hpp" # Public headers.
        EXCLUDE_REGEXES
            "include/mongocxx/doc\.hpp" # Doc header.
            "include/.*/(prelude|postlude)\.hpp" # Macro guard headers.
            "include/mongocxx/v_noabi/mongocxx/config/.*\.hpp" # v_noabi config headers.
    )
endif()

set_dist_list(src_mongocxx_test_DIST
    CMakeLists.txt
    bulk_write.cpp
    catch_helpers.cpp
    catch_helpers.hh
    catch.cpp
    change_streams.cpp
    client_helpers.cpp
    client_helpers.hh
    client_session.cpp
    client_side_encryption.cpp
    client.cpp
    collection_mocked.cpp
    collection.cpp
    conversions.cpp
    database.cpp
    gridfs/bucket.cpp
    gridfs/downloader.cpp
    gridfs/uploader.cpp
    hint.cpp
    index_view.cpp
    instance.cpp
    logging.cpp
    model/delete_many.cpp
    model/delete_one.cpp
    model/insert_one.cpp
    model/replace_one.cpp
    model/update_many.cpp
    model/update_one.cpp
    options/aggregate.cpp
    options/bulk_write.cpp

=== debian/changelog ===
mongo-cxx-driver (4.0.0-1) experimental; urgency=medium

  * New upstream release
  * Drop Kyle Kloberdanz as uploader
  * Bump dependency on libmongoc-dev
  * Drop MNMLSTC build profile and Boost dependency

 -- Roberto C. Sanchez <roberto@connexer.com>  Tue, 26 Nov 2024 12:36:16 -0500

mongo-cxx-driver (3.11.0-1) experimental; urgency=medium

  * New upstream release
  * d/rules: set -DENABLE_TESTS=OFF (since upstream CI is very thorough)
  * d/copyright: remove references to removed files

 -- Roberto C. Sanchez <roberto@connexer.com>  Wed, 02 Oct 2024 17:21:34 -0400

mongo-cxx-driver (3.10.2-1) experimental; urgency=medium

  * New upstream release
  * Bump dependency on libmongoc-dev
  * Update to Standards-Version 4.7.0 (no changes)

 -- Roberto C. Sanchez <roberto@connexer.com>  Thu, 27 Jun 2024 14:33:50 -0400

mongo-cxx-driver (3.10.1-1) experimental; urgency=medium

  * New upstream release

 -- Kyle Kloberdanz <kyle.kloberdanz@mongodb.com>  Wed, 13 Mar 2024 17:01:46 -0500

mongo-cxx-driver (3.9.0-1) experimental; urgency=medium

  * New upstream release

 -- Kyle Kloberdanz <kyle.kloberdanz@mongodb.com>  Wed, 08 Nov 2023 15:27:55 -0600

mongo-cxx-driver (3.8.1-1) experimental; urgency=medium

  * New upstream release

 -- Kyle Kloberdanz <kyle.kloberdanz@mongodb.com>  Fri, 06 Oct 2023 19:32:54 +0000

mongo-cxx-driver (3.8.0-1) experimental; urgency=medium

  * New upstream release
  * Bump dependency on libmongoc-dev

 -- Kyle Kloberdanz <kyle.kloberdanz@mongodb.com>  Mon, 26 Jun 2023 13:56:18 +0000

mongo-cxx-driver (3.7.1-1) experimental; urgency=medium

  * New upstream release
  * Update to Standards-Version 4.6.2 (no changes)

 -- Kyle Kloberdanz <kyle.kloberdanz@mongodb.com>  Thu, 16 Mar 2023 11:33:43 -0500

mongo-cxx-driver (3.7.0-1) experimental; urgency=medium

  * New upstream release
  * Bump dependency on libmongoc-dev
  * Update to Standards-Version 4.6.1 (no changes)

 -- Roberto C. Sanchez <roberto@connexer.com>  Mon, 03 Oct 2022 16:14:30 -0400

mongo-cxx-driver (3.6.7-1) experimental; urgency=medium

  * New upstream release

 -- Roberto C. Sanchez <roberto@connexer.com>  Thu, 05 May 2022 17:58:52 -0400

mongo-cxx-driver (3.6.6-1) experimental; urgency=medium

  * New upstream release
  * Drop Samantha Ritter as uploader
  * Update to Standards-Version 4.6.0 (no changes)

 -- Roberto C. Sanchez <roberto@connexer.com>  Sat, 09 Oct 2021 06:34:44 -0400

mongo-cxx-driver (3.6.5-1) experimental; urgency=medium

  * New upstream release

 -- Roberto C. Sanchez <roberto@connexer.com>  Fri, 04 Jun 2021 17:27:05 -0400

=== debian/control ===
Source: mongo-cxx-driver
Priority: optional
Maintainer: Mongo C++ Driver Team <mongo-cxx-driver-debian@googlegroups.com>
Uploaders: Kevin Albertson <kevin.albertson@mongodb.com>,
           Roberto C. Sanchez <roberto@connexer.com>
Build-Depends: debhelper (>= 11),
               cmake,
               pkgconf,
               libmongoc-dev (>= 1.29.0),
               libsasl2-dev,
               libutf8proc-dev,
               doxygen
Standards-Version: 4.7.0
Section: libs
Homepage: https://mongocxx.org/
Vcs-Git: https://github.com/mongodb/mongo-cxx-driver.git
Vcs-Browser: https://github.com/mongodb/mongo-cxx-driver/tree/master

Package: libmongocxx-dev
Section: libdevel
Architecture: any
Depends: libmongocxx-noabi (= ${binary:Version}),
         libbsoncxx-dev (= ${binary:Version}),
         libssl-dev,
         zlib1g-dev,
         libsnappy-dev,
         libutf8proc-dev,
         ${misc:Depends}
Description: MongoDB C++ client library - dev files
 libmongocxx is the officially supported MongoDB client library for C++
 applications.
 .
 This package contains all files necessary to develop applications which
 use libmongocxx.

Package: libmongocxx-noabi
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: MongoDB C++ client library - runtime files
 libmongocxx is the officially supported MongoDB client library for C++
 applications.
 .
 This package contains the libmongocxx runtime libraries, for applications that
 have been built with libmongocxx.

Package: libmongocxx-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: MongoDB C++ client library - documentation
 libmongocxx is the officially supported MongoDB client library for C++
 applications.
 .
 This package contains the documentation for libmongocxx and libbsoncxx.

Package: libbsoncxx-dev
Section: libdevel
Architecture: any
Depends: libbsoncxx-noabi (= ${binary:Version}),
         ${misc:Depends}
Description: Library to parse and generate BSON documents - dev files
 libbsoncxx parses and generates BSON documents, the data format for
 MongoDB. It is a dependency for libmongocxx, the MongoDB client library,
 for which it provides BSON support as well as platform-compatibility
 functions and macros.
 .
 This package contains all files necessary to develop applications which
 use libbsoncxx.

Package: libbsoncxx-noabi
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Library to parse and generate BSON documents - runtime files
 libbsoncxx parses and generates BSON documents, the data format for
 MongoDB. It is a dependency for libmongocxx, the MongoDB client library,
 for which it provides BSON support as well as platform-compatibility
 functions and macros.
 .
 This package contains the libbsoncxx runtime libraries, for applications that
 have been built with libbsoncxx.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
include /usr/share/dpkg/pkg-info.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND := -lpthread

# main packaging script based on dh7 syntax
%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -B$(CURDIR)/build -- \
	-DBUILD_VERSION=$(DEB_VERSION_UPSTREAM) \
	-DENABLE_TESTS=OFF \
	-DENABLE_UNINSTALL=OFF

override_dh_auto_build:
	dh_auto_build -B$(CURDIR)/build -- all doxygen-current

override_dh_auto_install:
	dh_auto_install -B$(CURDIR)/build
	find $(CURDIR)/debian/tmp -type d -empty -delete
	rm -f $(CURDIR)/debian/tmp/usr/share/mongo-cxx-driver/LICENSE

override_dh_auto_test:
	# do nothing

override_dh_missing:
	dh_missing --fail-missing
